﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'WebSocket class
Sub Class_Globals
	Private ws As WebSocket
End Sub

Public Sub Initialize
	Private btnswitchcheckbox5 As JQueryElement	
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	ws = WebSocket1
	Log("WebSocket_Connected")
End Sub

Private Sub WebSocket_Disconnected

End Sub

Private Sub checkbox_event(params As Map)
'  	Log("checkbox1_event :: Start")
	'Determine which switch has changed
	Dim switch As  String = params.Get("id")
	Log($"Switch ${switch} changed state to ${params.Get("state")} "$)
	'Take any action
	Select switch
		Case "checkbox1"
			Log($"Take action for CheckBox1"$)
		'Add more
	End Select
'  	Log("checkbox1_event :: End")
End Sub

'Use the bootstrap  reference
'If the second parameter is omitted, the method return the current value.
Private Sub GetCheckBoxState(mcheckbox As String) As Boolean
	Dim jqCheckBox As JQueryElement = ws.GetElementByID(mcheckbox)
	Dim ftCheckBox As Future = jqCheckBox.RunMethodWithResult("bootstrapSwitch",Array("state"))
	Log($"Checkbox ${mcheckbox} has state ${ftCheckBox.Value}"$)
	Return ftCheckBox.Value
End Sub

Private Sub SetCheckBoxState(mcheckbox As String, state As Boolean)
'	Log($"SetCheckBoxState :: Start ${mcheckbox} / ${state}"$)
	Dim jqCheckBox As JQueryElement = ws.GetElementByID(mcheckbox)
	jqCheckBox.RunMethod("bootstrapSwitch",Array("state", state))
	Log($"Checkbox ${mcheckbox} state set to ${state}"$)
'	Log($"SetCheckBoxState :: End"$)
End Sub

Private Sub btnswitchcheckbox5_event(params As Map)
'	Log($"btnswitchcheckbox5_event :: Start"$)
	Dim state As Boolean = GetCheckBoxState("checkbox5")
'	Log($"btnswitchcheckbox5_event: State is ${state}"$)
	SetCheckBoxState("checkbox5", Not(state))	
	ws.flush
'	Log($"btnswitchcheckbox5_event :: End"$)
End Sub
